/*Begin of head for every patch*/
if exists(select * from "DBA"."subRegistry" WHERE registryid='System'and subregistryid='Patch')
then  
   Delete from SubRegistry where registryid='System'and subregistryid='Patch'
end if;
/*End of head for every patch*/

/*----------------------------
 SSS CONTRIBUTION wef APRIL 2019
-----------------------------*/
/*----------------------------
 Insert Policy
-----------------------------*/
if not exists(select * from CPFPolicy where CPFPolicyId = 'SSSYr2019Apr' ) then
	Insert into CPFPolicy (CPFPolicyId, CPFGovernment, CPFPolicyDesc) Values('SSSYr2019Apr',1,'SSS for Year 2019');


	if not exists(select * from CPFTableCode  where CPFTableCodeId = 'SSS19') then
	  Insert into CPFTableCode (CPFTableCodeId, CPFResidenceTypeId, CPFSchemeId, CPFTableDesc, CPFPeriodCapping, CPFLessThanCapping, CPFGreaterThanCapping) Values('SSS19','Local','SSS','',0,0,0);
	  Insert into CPFPolicyMember (CPFPolicyId, CPFTableCodeId) Values('SSSYr2019Apr','SSS19');
	end if;

	/*------------------------------
	 Insert Formula
	--------------------------------*/
	if not exists(select * from Formula where Locate(FormulaId,'SSS19') = 1 and FormulaCategory='ManContriFormula') then

	/* Insert Formula */
	/* Employer Rate */
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$0ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19250ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19750ERSS',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$0EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19250EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19750EREC',1,0,0,'ManContriFormula','ER','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$0EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19250EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19750EESS',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$0EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$2750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$3750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$4750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$5750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$6750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$7750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$8750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$9750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$10750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$11750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$12750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$13750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$14750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$15750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$16750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$17750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$18750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19250EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);
	Insert into Formula (FormulaId, FormulaActive, FormulaPreprocess, FormulaRecurring, FormulaCategory, FormulaSubCategory, FormulaType, FormulaRangeBasis, FormulaDesc, FormulaExRateId, FormulaStage, FormulaRank) Values('SSS19$19750EEF2',1,0,0,'ManContriFormula','EE','T1','','','',0,0);

	/* Insert FormulaRange */
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$0ERSS',1,0,0,'C1;',160,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2250ERSS',1,0,0,'C1;',200,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2750ERSS',1,0,0,'C1;',240,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3250ERSS',1,0,0,'C1;',280,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3750ERSS',1,0,0,'C1;',320,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4250ERSS',1,0,0,'C1;',360,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4750ERSS',1,0,0,'C1;',400,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5250ERSS',1,0,0,'C1;',440,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5750ERSS',1,0,0,'C1;',480,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6250ERSS',1,0,0,'C1;',520,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6750ERSS',1,0,0,'C1;',560,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7250ERSS',1,0,0,'C1;',600,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7750ERSS',1,0,0,'C1;',640,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8250ERSS',1,0,0,'C1;',680,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8750ERSS',1,0,0,'C1;',720,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9250ERSS',1,0,0,'C1;',760,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9750ERSS',1,0,0,'C1;',800,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10250ERSS',1,0,0,'C1;',840,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10750ERSS',1,0,0,'C1;',880,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11250ERSS',1,0,0,'C1;',920,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11750ERSS',1,0,0,'C1;',960,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12250ERSS',1,0,0,'C1;',1000,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12750ERSS',1,0,0,'C1;',1040,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13250ERSS',1,0,0,'C1;',1080,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13750ERSS',1,0,0,'C1;',1120,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14250ERSS',1,0,0,'C1;',1160,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14750ERSS',1,0,0,'C1;',1200,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15250ERSS',1,0,0,'C1;',1240,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15750ERSS',1,0,0,'C1;',1280,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16250ERSS',1,0,0,'C1;',1320,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16750ERSS',1,0,0,'C1;',1360,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17250ERSS',1,0,0,'C1;',1400,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17750ERSS',1,0,0,'C1;',1440,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18250ERSS',1,0,0,'C1;',1480,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18750ERSS',1,0,0,'C1;',1520,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19250ERSS',1,0,0,'C1;',1560,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19750ERSS',1,0,0,'C1;',1600,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$0EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13750EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14250EREC',1,0,0,'C1;',10,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19250EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19750EREC',1,0,0,'C1;',30,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$0EESS',1,0,0,'C1;',80,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2250EESS',1,0,0,'C1;',100,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2750EESS',1,0,0,'C1;',120,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3250EESS',1,0,0,'C1;',140,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3750EESS',1,0,0,'C1;',160,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4250EESS',1,0,0,'C1;',180,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4750EESS',1,0,0,'C1;',200,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5250EESS',1,0,0,'C1;',220,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5750EESS',1,0,0,'C1;',240,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6250EESS',1,0,0,'C1;',260,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6750EESS',1,0,0,'C1;',280,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7250EESS',1,0,0,'C1;',300,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7750EESS',1,0,0,'C1;',320,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8250EESS',1,0,0,'C1;',340,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8750EESS',1,0,0,'C1;',360,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9250EESS',1,0,0,'C1;',380,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9750EESS',1,0,0,'C1;',400,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10250EESS',1,0,0,'C1;',420,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10750EESS',1,0,0,'C1;',440,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11250EESS',1,0,0,'C1;',460,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11750EESS',1,0,0,'C1;',480,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12250EESS',1,0,0,'C1;',500,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12750EESS',1,0,0,'C1;',520,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13250EESS',1,0,0,'C1;',540,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13750EESS',1,0,0,'C1;',560,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14250EESS',1,0,0,'C1;',580,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14750EESS',1,0,0,'C1;',600,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15250EESS',1,0,0,'C1;',620,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15750EESS',1,0,0,'C1;',640,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16250EESS',1,0,0,'C1;',660,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16750EESS',1,0,0,'C1;',680,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17250EESS',1,0,0,'C1;',700,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17750EESS',1,0,0,'C1;',720,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18250EESS',1,0,0,'C1;',740,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18750EESS',1,0,0,'C1;',760,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19250EESS',1,0,0,'C1;',780,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19750EESS',1,0,0,'C1;',800,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$0EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$2750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$3750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$4750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$5750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$6750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$7750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$8750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$9750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$10750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$11750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$12750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$13750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$14750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$15750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$16750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$17750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$18750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19250EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');
	Insert into FormulaRange (FormulaId,FormulaRangeId,Maximum,Minimum,Formula,Constant1,Constant2,Constant3,Constant4,Constant5,Keywords1,Keywords2,Keywords3,Keywords4,Keywords5,Keywords6,Keywords7,Keywords8,Keywords9,Keywords10,UserDef1,UserDef2,UserDef3,UserDef4,UserDef5,F1,F2,F3,F4,F5,F6,F7,F8,F9,F10,P1,P2,P3,P4,P5,P6,P7,P8,P9,P10)Values('SSS19$19750EEF2',1,0,0,'C1;',0,0,0,0,0,'','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','','');


	/* Insert Table Component */
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',0,0,'SSS19$0EESS','SSS19$0ERSS',2250,99,'SSS19$0EEF2','SSS19$0EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',2250,0,'SSS19$2250EESS','SSS19$2250ERSS',2750,99,'SSS19$2250EEF2','SSS19$2250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',2750,0,'SSS19$2750EESS','SSS19$2750ERSS',3250,99,'SSS19$2750EEF2','SSS19$2750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',3250,0,'SSS19$3250EESS','SSS19$3250ERSS',3750,99,'SSS19$3250EEF2','SSS19$3250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',3750,0,'SSS19$3750EESS','SSS19$3750ERSS',4250,99,'SSS19$3750EEF2','SSS19$3750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',4250,0,'SSS19$4250EESS','SSS19$4250ERSS',4750,99,'SSS19$4250EEF2','SSS19$4250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',4750,0,'SSS19$4750EESS','SSS19$4750ERSS',5250,99,'SSS19$4750EEF2','SSS19$4750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',5250,0,'SSS19$5250EESS','SSS19$5250ERSS',5750,99,'SSS19$5250EEF2','SSS19$5250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',5750,0,'SSS19$5750EESS','SSS19$5750ERSS',6250,99,'SSS19$5750EEF2','SSS19$5750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',6250,0,'SSS19$6250EESS','SSS19$6250ERSS',6750,99,'SSS19$6250EEF2','SSS19$6250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',6750,0,'SSS19$6750EESS','SSS19$6750ERSS',7250,99,'SSS19$6750EEF2','SSS19$6750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',7250,0,'SSS19$7250EESS','SSS19$7250ERSS',7750,99,'SSS19$7250EEF2','SSS19$7250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',7750,0,'SSS19$7750EESS','SSS19$7750ERSS',8250,99,'SSS19$7750EEF2','SSS19$7750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',8250,0,'SSS19$8250EESS','SSS19$8250ERSS',8750,99,'SSS19$8250EEF2','SSS19$8250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',8750,0,'SSS19$8750EESS','SSS19$8750ERSS',9250,99,'SSS19$8750EEF2','SSS19$8750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',9250,0,'SSS19$9250EESS','SSS19$9250ERSS',9750,99,'SSS19$9250EEF2','SSS19$9250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',9750,0,'SSS19$9750EESS','SSS19$9750ERSS',10250,99,'SSS19$9750EEF2','SSS19$9750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',10250,0,'SSS19$10250EESS','SSS19$10250ERSS',10750,99,'SSS19$10250EEF2','SSS19$10250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',10750,0,'SSS19$10750EESS','SSS19$10750ERSS',11250,99,'SSS19$10750EEF2','SSS19$10750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',11250,0,'SSS19$11250EESS','SSS19$11250ERSS',11750,99,'SSS19$11250EEF2','SSS19$11250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',11750,0,'SSS19$11750EESS','SSS19$11750ERSS',12250,99,'SSS19$11750EEF2','SSS19$11750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',12250,0,'SSS19$12250EESS','SSS19$12250ERSS',12750,99,'SSS19$12250EEF2','SSS19$12250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',12750,0,'SSS19$12750EESS','SSS19$12750ERSS',13250,99,'SSS19$12750EEF2','SSS19$12750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',13250,0,'SSS19$13250EESS','SSS19$13250ERSS',13750,99,'SSS19$13250EEF2','SSS19$13250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',13750,0,'SSS19$13750EESS','SSS19$13750ERSS',14250,99,'SSS19$13750EEF2','SSS19$13750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',14250,0,'SSS19$14250EESS','SSS19$14250ERSS',14750,99,'SSS19$14250EEF2','SSS19$14250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',14750,0,'SSS19$14750EESS','SSS19$14750ERSS',15250,99,'SSS19$14750EEF2','SSS19$14750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',15250,0,'SSS19$15250EESS','SSS19$15250ERSS',15750,99,'SSS19$15250EEF2','SSS19$15250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',15750,0,'SSS19$15750EESS','SSS19$15750ERSS',16250,99,'SSS19$15750EEF2','SSS19$15750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',16250,0,'SSS19$16250EESS','SSS19$16250ERSS',16750,99,'SSS19$16250EEF2','SSS19$16250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',16750,0,'SSS19$16750EESS','SSS19$16750ERSS',17250,99,'SSS19$16750EEF2','SSS19$16750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',17250,0,'SSS19$17250EESS','SSS19$17250ERSS',17750,99,'SSS19$17250EEF2','SSS19$17250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',17750,0,'SSS19$17750EESS','SSS19$17750ERSS',18250,99,'SSS19$17750EEF2','SSS19$17750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',18250,0,'SSS19$18250EESS','SSS19$18250ERSS',18750,99,'SSS19$18250EEF2','SSS19$18250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',18750,0,'SSS19$18750EESS','SSS19$18750ERSS',19250,99,'SSS19$18750EEF2','SSS19$18750EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',19250,0,'SSS19$19250EESS','SSS19$19250ERSS',19750,99,'SSS19$19250EEF2','SSS19$19250EREC');
	Insert Into CPFTableComponent (CPFTableCodeId, MinSalary, MinCPFAge, EEOrdCPFFormula, EROrdCPFFormula, MaxSalary, MaxCPFAge, EEAddCPFFormula, ERAddCPFFormula)Values('SSS19',19750,0,'SSS19$19750EESS','SSS19$19750ERSS',999999,99,'SSS19$19750EEF2','SSS19$19750EREC');
	end if;

	/* Set default SSS Policy */
	Update Subregistry Set ShortStringAttr = 'SSSYr2019Apr' 
	where RegistryId = 'PaySetupData' and SubregistryId = 'SSSProgPolicyId';

	/* Statutory Contribution Progression*/ 
	Insert into MandatoryContributeProg (EmployeeSysId, 
	MandContriEffDate,
	MandContriCareerId, 
	MandContriPolicyId, 
	MandContriCurrent,
	MandContriRemarks,
	MandContriSchemeId
	)
	Select CurProg.EmployeeSysId, 
	'2019-04-01', 
	'None',
	'SSSYr2019Apr', 
	0,
	'',
	'SSS'
	From PayEmployee PE join MandatoryContributeProg CurProg
	On PE.EmployeeSysId = CurProg.EmployeeSysId
	Left Join MandatoryContributeProg NewProg ON CurProg.EmployeeSysId = NewProg.EmployeeSysId and CurProg.MandContriSchemeId = NewProg.MandContriSchemeId 
	     and NewProg.MandContriEffDate = '2019-04-01'
	Where CurProg.MandContriCurrent = 1 and CurProg.MandContriEffDate < '2019-04-01' and CurProg.MandContriSchemeId = 'SSS' and CurProg.MandContriSchemeId != ''
	And NewProg.EmployeeSysId is null
	And (PE.LastPayDate = '1899-12-30' Or PE.LastPayDate >= '2019-04-01');


	/* Update progression if progression’s effective date is equal or greater than 2019-04-01, scheme is not blank & policy is SSSYr2014Jan */
	Update MandatoryContributeProg
	Set MandContriPolicyId = 'SSSYr2019Apr'
	Where MandContriEffDate >= '2019-04-01' 
	AND MandContriPolicyId = 'SSSYr2014Jan' And MandContriSchemeId = 'SSS'
	AND MandContriSchemeId != '';
end if;


/*Begin of tailor for every patch*/
INSERT into "DBA"."subRegistry"(registryid,subregistryid,IntegerAttr) values('System','Patch',1);
commit work;
/*End of tailor for every patch*/